function [Inertie]=Inertie_Tetra(XA,YA,ZA,XB,YB,ZB,XC,YC,ZC,XD,YD,ZD)
%%donne le tenseur d'inertie d'un tetradre par rapport au point D%%

%Orientation
if dot(cross([XB-XA,YB-YA,ZB-ZA],[XC-XA,YC-YA,ZC-ZA]),[XD-XA,YD-YA,ZD-ZA])<0
    x=XB;
    y=YB;
    z=ZB;
    XB=XC;
    YB=YC;
    ZB=ZC;
    XC=x;
    YC=y;
    ZC=z;
end

%Nouveau repre
Xp=[XC-XD,YC-YD,ZC-ZD]/sqrt((XC-XD)^2+(YC-YD)^2+(ZC-ZD)^2);
Xpx=Xp(1,1);
Xpy=Xp(1,2);
Xpz=Xp(1,3);
Zp=cross([XC-XD,YC-YD,ZC-ZD],[XB-XD,YB-YD,ZB-ZD]);
Zp=Zp/sqrt(Zp(1,1)^2+Zp(1,2)^2+Zp(1,3)^2);
Zpx=Zp(1,1);
Zpy=Zp(1,2);
Zpz=Zp(1,3);
Yp=cross(Zp,Xp);
Ypx=Yp(1,1);
Ypy=Yp(1,2);
Ypz=Yp(1,3);
Alpha=[Xpx,Xpy,Xpz;Ypx,Ypy,Ypz;Zpx,Zpy,Zpz];

%Coordonnes dans le repre local
X1=(XA-XD)*Xpx+(YA-YD)*Xpy+(ZA-ZD)*Xpz;
Y1=(XA-XD)*Ypx+(YA-YD)*Ypy+(ZA-ZD)*Ypz;
Z1=(XA-XD)*Zpx+(YA-YD)*Zpy+(ZA-ZD)*Zpz;
X2=(XB-XD)*Xpx+(YB-YD)*Xpy+(ZB-ZD)*Xpz;
Y2=(XB-XD)*Ypx+(YB-YD)*Ypy+(ZB-ZD)*Ypz;
X3=(XC-XD)*Xpx+(YC-YD)*Xpy+(ZC-ZD)*Xpz;

%Matrice d'inertie dans axes locaux
A=X3*Y2*Z1/60*(X1^2+X2^2+X3^2+X1*X2+X1*X3+X2*X3);
B=X3*Y2*Z1/60*(Y1^2+Y2^2+Y1*Y2);
C=X3*Y2*Z1^3/60;
D=X3*Y2*Z1/120*(2*X1*Y1+X1*Y2+X3*Y1+X3*Y2+X2*Y1+2*X2*Y2);
E=X3*Y2*Z1^2/120*(2*X1+X2+X3);
F=X3*Y2*Z1^2/120*(2*Y1+Y2);
Inertie=[B+C,-D,-E;-D,A+C,-F;-E,-F,A+B];

%Tenseur d'inertie dans axes d'origine
Inertie=Alpha'*Inertie*Alpha;
