%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% PROGRAM INSTALLATION %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%     PRESS F5    %%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
geode='geode4.mat';
load(geode)
D=1;
for N=2:64
    disp(['Creating matrix of mode ',num2str(N),'/64'])
    Cn=zeros(128,1);
    Cn(N+1,1)=D;
    Cn(129-N,1)=D;
    [COV,Autocorrelation,Distance]=Spec_2_Autocorr(Cn);
    load(geode);
    [Dist_Angulaires,Autocov_Mat]=Fill_Autocov(geode,COV,Autocorrelation,Distance);
    [EigenVectors,EigenValues]=eig(Autocov_Mat);
    EigenVectors=flipud(sortrows(cat(2,real(diag(EigenValues)),real(EigenVectors)'),1));
    EigenValues=EigenVectors(:,1);
    EigenVectors=EigenVectors(:,2:size(EigenVectors,2))';
    EigenValues_SDP=cat(1,EigenValues(1:2*N+1,1),zeros(size(EigenValues,1)-(2*N+1),1));
    Autocov_Mat_SDP=EigenVectors*diag(EigenValues_SDP)*EigenVectors';
    Autocov_Mat_SDP=Autocov_Mat_SDP/Autocov_Mat_SDP(1,1)*COV^2;
    save(['Mode_' num2str(N) '_Fourier_' geode],'Autocov_Mat_SDP')
end

disp(['Generation of the calibration mesh :'])
X=rand(100,1);
Y=rand(100,1);
Z=rand(100,1);
load('Unit_Cube_Domain.mat')
[X,Y,Z,Vertices,Cellules]=VoronoiDomain3D(X,Y,Z,Points_Domain,Struc_Domain);
Centres=[];
VolumesGrains=[];
VolumesCells=[];
RadsCells=[];
for i=1:size(Cellules,1)
    disp(['Pre-filling Particle ',num2str(i),'/',num2str(size(Cellules,1))])
    Points=Vertices(Cellules{i,1},:);
    Tri=convhulln(Points);
    [Points_Cell,Struc_Cell]=Tri2Domain(Points,Tri);
    [Xc,Yc,Zc,VolumeCell]=PropDomain(Points_Cell,Struc_Cell,1000);
    Centre=[Xc,Yc,Zc];
    RadCell=R_Intersect(Angles(:,2),Angles(:,1),Centre,Points_Cell,Struc_Cell);
    Centres(i,1:3)=Centre;
    VolumesCells(i,1)=VolumeCell;
    RadsCells(1:size(RadCell,1),i)=RadCell;
end
save('CalibrationMesh.mat','Centres','VolumesCells','RadsCells','Vertices','Cellules')