function Plot_Voronoi3D(Vertices,Cellules,Type,Couleur,Param,Minmax)
%% Type : 1=Segments ; 2=Faces %%
figure
if Type==1
    Segments=[];
    for i=1:size(Cellules,1)
        C=transpose(Cellules{i,1});
        P=Vertices(C,:);
        K=convhulln(P+(10^-10)*randn(size(P,1),3));
        for j=1:size(K,1)
            Segments=cat(1,Segments,[C(K(j,1),1),C(K(j,2),1);C(K(j,2),1),C(K(j,3),1);C(K(j,3),1),C(K(j,1),1)]);
        end
    end
    Segments=transpose(sort(transpose(Segments)));
    Segments=sortrows(Segments,[1,2]);
    plot3([Vertices(Segments(1,1),1),Vertices(Segments(1,2),1)],[Vertices(Segments(1,1),2),Vertices(Segments(1,2),2)],[Vertices(Segments(1,1),3),Vertices(Segments(1,2),3)],'-b')
    hold on
    for i=2:size(Segments,1)
        if Segments(i,:)==Segments(i-1,:)
            continue
        end
        plot3([Vertices(Segments(i,1),1),Vertices(Segments(i,2),1)],[Vertices(Segments(i,1),2),Vertices(Segments(i,2),2)],[Vertices(Segments(i,1),3),Vertices(Segments(i,2),3)],'-b','Marker','.','MarkerFaceColor','r','MarkerEdgeColor','r')
    end
    axis equal
elseif Type==2
    for i=1:size(Cellules,1)
        C=transpose(Cellules{i,1});
        P=Vertices(C,:);
        M=mean(P);
        K=convhulln(P+(10^-10)*randn(size(P,1),3));
        if size(Couleur,2)==1
            %Color=Translate_Color(sqrt(Couleur(i,1)),sqrt(min(Couleur)),sqrt(max(Couleur)));
            Color=Translate_Color(log(Couleur(i,1)),log(Minmax(1)),log(Minmax(2)));
        elseif size(Couleur,2)==3
            Color=Couleur(i,:);
        end
        %if Param==0
            %trisurf(K,P(:,1),P(:,2),P(:,3),'Linestyle','none','Facecolor',Color);
        %else
            surf1=trisurf(K,P(:,1)+Param*M(1),P(:,2)+Param*M(2),P(:,3)+Param*M(3),'Linestyle','none','Facecolor',Color);%,'BackFaceLighting','reverselit');
        %end
        hold on
    end
    axis equal
    if Param>0
        camlight right
        set(gcf,'Renderer','zbuffer')
        set(surf1,'AmbientStrength',.3,'DiffuseStrength',.3,'SpecularStrength',.1,'SpecularExponent',10)
    end
end
