function [X,Y,Z,Neighbors,Historic,Cellules,Vertices,Pdf_Volumes,PdfFin_Cible,Grains,Centres,VolumesGrains,VolumesCells,ListSpheres,Properties,Cn,Inertias]=Secondary_Program(FileName,MeshName,Nparticles,TargetVolumeCOV,Domain,NiterMax,TargetError,TargetSolidFraction,NmodesOptim,TypeSpectrum,FileSpectrum,DescriptorD2,DescriptorD3,SpectrumDecay1,DescriptorD8,SpectrumDecay2,Dmax,Rmin,Pmax,Nstat);
disp(' ')
load(Domain)
Xmin=min(Points_Domain(:,1));
Xmax=max(Points_Domain(:,1));
Ymin=min(Points_Domain(:,2));
Ymax=max(Points_Domain(:,2));
Zmin=min(Points_Domain(:,3));
Zmax=max(Points_Domain(:,3));
[V]=Volume_Domain(Points_Domain,Struc_Domain);
Ns=floor(Nparticles/V*(Xmax-Xmin)*(Ymax-Ymin)*(Zmax-Zmin));
if TargetVolumeCOV>0.4
    X=Xmin+(Xmax-Xmin)*rand(Ns,1);
    Y=Ymin+(Ymax-Ymin)*rand(Ns,1);
    Z=Zmin+(Zmax-Zmin)*rand(Ns,1);
else
    H=Halton(Ns,3);
    X=Xmin+(Xmax-Xmin)*H(:,1);
    Y=Ymin+(Ymax-Ymin)*H(:,2);
    Z=Zmin+(Zmax-Zmin)*H(:,3);
end
[X,Y,Z,Vertices,Cellules]=VoronoiDomain3D(X,Y,Z,Points_Domain,Struc_Domain);
[X,Y,Z,CellsVolumes,Neighbors,Historic,Cellules,Vertices]=IMC3D(X,Y,Z,Domain,TargetVolumeCOV,NiterMax,TargetError,MeshName);
Npoints=size(X,1);
[Vtot]=Volume_Domain(Points_Domain,Struc_Domain);
VolMoy=Vtot/Npoints;
VolStd=VolMoy*TargetVolumeCOV;
[MuN,SigN]=Gauss_to_Log(VolMoy,VolStd);
Voltest=exp(MuN+SigN*randn(1000000,1));
Classes=[max([0,VolMoy-5*VolStd]):VolStd/5:VolMoy+5*VolStd]';
Pdf_Volumes=PDF(CellsVolumes,Classes);
Pdf_Cible=PDF(Voltest,Classes);
ClassesFin=[max([0,VolMoy-5*VolStd]):VolStd/25:VolMoy+5*VolStd]';
PdfFin_Cible=PDF(Voltest,ClassesFin);
Erreur=sum(abs(Pdf_Volumes(:,3)-Pdf_Cible(:,3)))*(Pdf_Volumes(3,1)-Pdf_Volumes(2,1));
save(MeshName)

load('geode3.mat')
Structure3=Structure;
Angles3=Angles;
geode='geode4.mat';
load(geode)
if TypeSpectrum==0
    if DescriptorD2==0
        DescriptorD2=10^-5;
    end
    if DescriptorD3==0
        DescriptorD3=10^-5;
    end
    if DescriptorD8==0
        DescriptorD8=10^-5;
    end
    [Cn]=Spectre(128,1,0,DescriptorD2,DescriptorD3,SpectrumDecay1,DescriptorD8,SpectrumDecay2);
else
    load(FileSpectrum)
end
disp(['Construction of the autocorrelation matrix'])
disp(' ')
Autocov_Mat=Mat_Construction(Cn,geode);
[EigenVectors,EigenValues]=eig(Autocov_Mat);
EigenVectors=flipud(sortrows(cat(2,real(diag(EigenValues)),real(EigenVectors)'),1));
EigenValues=EigenVectors(:,1);
EigenVectors=EigenVectors(:,2:size(EigenVectors,2))';
Grains=cell(1,1);
Centres=zeros(size(Cellules,1),3);
VolumesGrains=zeros(size(Cellules,1),1);
VolumesCells=zeros(size(Cellules,1),1);
EigensCells=zeros(2562,size(Cellules,1));
RadsCells=zeros(2562,size(Cellules,1));
ListSpheres=cell(size(Grains,1),1);
Inertias=cell(size(Grains,1),3);
for i=1:size(Cellules,1)
    disp(['Pre-filling Particle ',num2str(i),'/',num2str(size(Cellules,1))])
    Points=Vertices(Cellules{i,1},:);
    Tri=convhulln(Points);
    [Points_Cell,Struc_Cell]=Tri2Domain(Points,Tri);
    [Centre,VolumeCell,RadCell,EigenCell]=PrefillCell3D(EigenVectors,geode,Points_Cell,Struc_Cell);
    Centres(i,1:3)=Centre;
    VolumesCells(i,1)=VolumeCell;
    EigensCells(1:size(EigenCell,1),i)=EigenCell;
    RadsCells(1:size(RadCell,1),i)=RadCell;
end
save(MeshName)
disp(' ')

Randoms=zeros(size(EigensCells,1),size(EigensCells,2));
for i=1:size(EigensCells,2)
    Randoms(:,i)=EigensCells(:,i)./(EigenValues(:,1).^0.5);
end
Correct=cat(2,mean(Randoms')',std(Randoms')');
for i=1:size(Cellules,1)
    disp(['Filling Particle ',num2str(i),'/',num2str(size(Cellules,1))])
    Points=Vertices(Cellules{i,1},:);
    Tri=convhulln(Points);
    [Points_Cell,Struc_Cell]=Tri2Domain(Points,Tri);
    Centre=Centres(i,:);
    EigenCell=EigensCells(:,i);
    RadCell=RadsCells(:,i);
    [Xgrain,Ygrain,Zgrain,Rgrain]=FillCell3D(Centre,EigenVectors,EigenValues,EigenCell,RadCell,NmodesOptim,geode,Correct,VolumesCells(i,1),TargetSolidFraction);
    VolumeGrain=Volume_Geode(Rgrain,Structure,Angles);
    Grains{i,1}=cat(2,Xgrain,Ygrain,Zgrain,Rgrain);
    VolumesGrains(i,1)=VolumeGrain;
    [Pd,Sd]=Tri2Domain(Grains{i,1}(:,1:3),Structure);
    [Spheres,PointsOK]=ODEC_Filling(Pd,Sd,Dmax*mean(Grains{i,1}(:,4)),Rmin*mean(Grains{i,1}(:,4)),Pmax);
    ListSpheres{i,1}=Spheres;
    [I,C,B,V]=Inertie_Geode(Rgrain(1:642,1),Structure3,Angles3);
    Inertias{i,1}=diag(I)';
    Inertias{i,2}=C;
    Inertias{i,3}=B;
end
disp(' ')

Properties=zeros(size(Cellules,1),21);
Done=zeros(size(Cellules,1),1);
if Nstat>size(Cellules,1)
    Nstat=size(Cellules,1);
end
for j=1:Nstat
    Sortie=0;
    while Sortie==0
        i=randint(1,1,[1,size(Cellules,1)]);
        if Done(i,1)==0
            Done(i,1)=1;
            Sortie=1;
        end
    end  
    disp(['Analysing Particle ',num2str(j),'/',num2str(Nstat)])
    Rmax=max(Grains{i,1}(:,4));
    [Pd,Sd]=Tri2Domain(Grains{i,1}(:,1:3),Structure);
    [Spheres,PointsOK]=ODEC_Filling(Pd,Sd,Rmax/100,Rmax/100,0.001);
    ListSpheres{i,1}=Spheres;
    [Flatness,Elongation,AspectRatio,Roundness,Circularity,Regularity,Tx,Ty,Tz,S,I,L,Rcirc,Rinsc,Surf,Surf_Conv,Vol,Vol_Conv,Q,Q_Conv]=Proprietes(Grains{i,1}(:,1),Grains{i,1}(:,2),Grains{i,1}(:,3),Grains{i,1}(:,4),geode,Spheres);
    Properties(j,1)=i;
    Properties(j,2)=Flatness;
    Properties(j,3)=Elongation;
    Properties(j,4)=AspectRatio;
    Properties(j,5)=Roundness;
    Properties(j,6)=Circularity;
    Properties(j,7)=Regularity;
    Properties(j,8)=Tx;
    Properties(j,9)=Ty;
    Properties(j,10)=Tz;
    Properties(j,11)=S;
    Properties(j,12)=I;
    Properties(j,13)=L;
    Properties(j,14)=Rcirc;
    Properties(j,15)=Rinsc;
    Properties(j,16)=Surf;
    Properties(j,17)=Surf_Conv;
    Properties(j,18)=Vol;
    Properties(j,19)=Vol_Conv;
    Properties(j,20)=Q;
    Properties(j,21)=Q_Conv;
end
Properties=sortrows(Properties,[1]);
disp(' ')
disp(['Solid Fraction : ',num2str(sum(VolumesGrains)/sum(VolumesCells))])
disp(['Grain Volume COV : ',num2str(std(VolumesGrains)/mean(VolumesGrains)*100)])
disp(['Average Flatness : ',num2str(mean(Properties(:,2)))])
disp(['Average Elongation : ',num2str(mean(Properties(:,3)))])
disp(['Average Aspect ratio : ',num2str(mean(Properties(:,4)))])
disp(['Average Roundness : ',num2str(mean(Properties(:,5)))])
disp(['Average Sphericity : ',num2str(mean(Properties(:,6)))])
disp(['Average Isoperimetric quotient : ',num2str(mean(Properties(:,20)))])

Plot_Voronoi3D(Vertices,Cellules,2,CellsVolumes,0.5,[min(CellsVolumes),max(CellsVolumes),]);
figure;bar(Pdf_Volumes(1:size(Pdf_Volumes,1)-1,1),Pdf_Volumes(1:size(Pdf_Volumes,1)-1,3));hold on;plot(PdfFin_Cible(1:size(PdfFin_Cible,1)-1,1),PdfFin_Cible(1:size(PdfFin_Cible,1)-1,3),'-r','Linewidth',3)
figure;plot(Historic(:,1),Historic(:,2),'-b');hold on
